#define IMGUI_DISABLE_INCLUDE_IMCONFIG_H
#define IMGUI_HAS_DOCK 1

#include "CommonHeaders.h"
#include "HotkeysManager.h"
#include "OSDManager.h"
#include <chrono>
#include <Windows.h>

// Screen informations
static int screenWidth = GetSystemMetrics(SM_CXSCREEN);
static int screenHeight = GetSystemMetrics(SM_CYSCREEN);
static float aspectRatio = (float)screenWidth / screenHeight;

// Core game dll functions declarations
typedef void (*SetBoolFn)(bool, bool);
typedef void (*SetFixesFn)(GameFixes ,bool);
typedef void (*SetIntFn)(int);
typedef void (*SetFloatFn)(float);

static HMODULE fixLib = nullptr;
static LONG g_coreInitialized = 0;
static LONG g_hotkeysInitialized = 0;
static LONG g_uniformReseted = 0;
static SetBoolFn SetFixEnabled = nullptr;
static SetFixesFn SetFixes = nullptr;
static SetIntFn SetFOV = nullptr;
static SetIntFn SetHUDScale = nullptr;
static SetIntFn SetCameraOffset = nullptr;
static SetFloatFn SetWorldTimeDilation = nullptr;
static SetFloatFn SetAITimeDilation = nullptr;
static SetFloatFn SetCameraSmoothness = nullptr;
static GetGameInfosStruct GetGameInfos = nullptr;

void SetFixesEnabled(GameFixes fix, bool value) {
    if (SetFixes) SetFixes(fix, value);
}

// Plugin variables for checkboxes and sliders
static bool fov_fix_enabled = false;
static bool Camera_fix_enabled = false;
static bool HUD_fix_enabled = false;
static bool CA_fix_enabled = false;
static bool Vignetting_fix_enabled = false;
static bool Fog_fix_enabled = false;
static bool Time_Dilation_fix_enabled = false;
static bool GodMode_fix_enabled = false;
static bool Ignore_hits_fix_enabled = false;
static bool Stealth_fix_enabled = false;
static bool fix_enabled = false;
static bool console = true;
static int worldFOVValue = 0;
static int HUDScaleValue = 0;
static int cameraOffsetValue = 0;
static float worldTimeDilationValue = 1.f;
static float AITimeDilationValue = 1.f;
static float cameraSmoothnessValue = 3.5f;
static float OSD_duration = 3.f;

// Overlays popups
static bool popup_Informations = false;
static bool show_log_overlay = false;
static std::string log_content;

// Plugin settings
const std::string SETTINGS_FILE = "./pluginsettings.ini";
const char* FIX_VERSION = "0.9.7";
const char* FIX_INFORMATIONS = "This fix allows to:\n - Control FOV in game.\n - Control camera distance.\n - Control HUD scaling.\n - Enable cheats.\n - Disable chromatic aberrations.\n - Disable vignetting.\n - Disable fog.\n - Re enable dev console.";
const char* DONATION_URL = "https://buymeacoffee.com/k4sh44";

// Scaling factor based on screen resolution
float scale = (float)screenHeight / 1200;

// Plugin sig
extern "C" __declspec(dllexport) const char* NAME = "The Callisto Protocol";
extern "C" __declspec(dllexport) const char* DESCRIPTION = "Reshade addon to re-enable console, control FOV, camera distance, HUD, some effects and enable cheats.";

// Prepare arrays of checkboxes for ImGui
static FixToggle individualFixes[] = {
    { "FOV", &fov_fix_enabled, GameFixes::FOV },
    { "Fog", &Fog_fix_enabled, GameFixes::Fog },
    { "Vignetting", &Vignetting_fix_enabled, GameFixes::Vignetting },
    { "Camera distance", &Camera_fix_enabled, GameFixes::Camera,
      "Experimental fix. Use at your own risk." },
    { "HUD scaling", &HUD_fix_enabled, GameFixes::HUD },
    { "Chromatic aberrations", &CA_fix_enabled, GameFixes::ChromaticAberrations }
};

static FixToggle cheatFixes[] = {
    { "Time dilation", &Time_Dilation_fix_enabled, GameFixes::TimeDilation, "ALT + 1 (top keyboard row) to toggle" },
    { "God mode", &GodMode_fix_enabled, GameFixes::GodMode, "ALT + 2 (top keyboard row) to toggle.\nJacob won't receive any damage." },
    { "Ignore hits", &Ignore_hits_fix_enabled, GameFixes::IgnoreHits, "ALT + 3 (top keyboard row) to toggle.\nJacob can't be hit." },
    { "Stealth mode",&Stealth_fix_enabled, GameFixes::Stealth, "ALT + 4 (top keyboard row) to toggle.\nEnemies won't attack you" }
};
// Prepare array of sliders for ImGui
static SliderFix sliders[6];

// Load and unload game core dll functions /!\ necessary
static void LoadFixDLL()
{
    // Ensure the Core dll will be called once
    if (InterlockedCompareExchange(&g_coreInitialized, 1, 0) != 0)
        return;

    if (GetModuleHandleA("TheCallistoProtocolCore.dll") == nullptr) {
        fixLib = LoadLibraryA("TheCallistoProtocolCore.dll");

        if (!fixLib) {
            MessageBoxA(nullptr, "Impossible to load game core dll", "Erreur", MB_OK);
            return;
        }

        SetFixEnabled = (SetBoolFn)GetProcAddress(fixLib, "SetFixEnabled");
        SetFixes = (SetFixesFn)GetProcAddress(fixLib, "SetFixesEnabled");
        SetFOV = (SetIntFn)GetProcAddress(fixLib, "SetFOV");
        SetHUDScale = (SetIntFn)GetProcAddress(fixLib, "SetHUDScale");
        SetCameraOffset = (SetIntFn)GetProcAddress(fixLib, "SetCameraOffset");
        SetWorldTimeDilation = (SetFloatFn)GetProcAddress(fixLib, "SetWorldTimeDilation");
        SetAITimeDilation = (SetFloatFn)GetProcAddress(fixLib, "SetAITimeDilation");
        SetCameraSmoothness = (SetFloatFn)GetProcAddress(fixLib, "SetCameraSmoothness");
        GetGameInfos = (GetGameInfosStruct)GetProcAddress(fixLib, "GetGameInfos");

        // Apply initial values loaded from settings
        if (SetFOV) SetFOV(worldFOVValue);
        if (SetHUDScale) SetHUDScale(HUDScaleValue);
        if (SetCameraOffset) SetCameraOffset(cameraOffsetValue);
        if (SetWorldTimeDilation) SetWorldTimeDilation(worldTimeDilationValue);
        if (SetAITimeDilation) SetAITimeDilation(AITimeDilationValue);
        if (SetCameraSmoothness) SetCameraSmoothness(cameraSmoothnessValue);
        if (SetFixEnabled) SetFixEnabled(fix_enabled, true);
        if (SetFixes) {
            SetFixes(GameFixes::FOV, fov_fix_enabled);
            SetFixes(GameFixes::Camera, Camera_fix_enabled);
            SetFixes(GameFixes::HUD, HUD_fix_enabled);
            SetFixes(GameFixes::ChromaticAberrations, CA_fix_enabled);
            SetFixes(GameFixes::Vignetting, Vignetting_fix_enabled);
            SetFixes(GameFixes::Fog, Fog_fix_enabled);
            SetFixes(GameFixes::TimeDilation, Time_Dilation_fix_enabled);
            SetFixes(GameFixes::GodMode, GodMode_fix_enabled);
            SetFixes(GameFixes::IgnoreHits, Ignore_hits_fix_enabled);
            SetFixes(GameFixes::Stealth, Stealth_fix_enabled);
            SetFixes(GameFixes::DevConsole, console);
        }

        // Declare sliders only when function pointers are initilized  (SetFOV ...)
        sliders[0] = { "In game additional FOV", "##FOVValue", SliderType::Int, &worldFOVValue, -20, 50, SetFOV };
        sliders[1] = { "Camera offset (*)", "##CameraOffset", SliderType::Int, &cameraOffsetValue, 0, 200, SetCameraOffset, nullptr, "Value is in cms." };
        sliders[2] = { "HUD scaling", "##HUDScale", SliderType::Int, &HUDScaleValue, 0, 40, SetHUDScale };
        sliders[3] = { "Camera smoothness (*)", "##CameraSmoothnessValue", SliderType::Float, &cameraSmoothnessValue, 2.f, 10.f, SetCameraSmoothness, "%.2f",
                       "The higher the value, the quicker the camera transition is." };
        sliders[4] = { "World time dilation", "##WorldTimeDilationValue", SliderType::Float, &worldTimeDilationValue, 0.f, 2.f, SetWorldTimeDilation, nullptr,
                       "Will affect everything in the world.\nDefault value is 1." };
        sliders[5] = { "AI time dilation", "##AITimeDilationValue", SliderType::Float, &AITimeDilationValue, 0.f, 2.f, SetAITimeDilation, nullptr,
                       "Will affect only enemies in the world.\nDefault value is 1." };
    }
}

// Settings functions
static void SaveSettings() {
    ini::IniFile pluginIniFile;
    pluginIniFile["1#General fix"].setComment(std::vector<std::string>{ "The following sections are saved by plugin",
                                                                        "You should not need to modify them",
                                                                        " ",
                                                                        "Controls if fix mod (globally) is enabled",
                                                                        "Set Console to false if you don't want dev console to be enabled"});
    pluginIniFile["1#General fix"]["Enabled"] = fix_enabled;
    pluginIniFile["1#General fix"]["Console"] = console;
    pluginIniFile["1#General fix"]["OSD duration"] = OSD_duration;
    pluginIniFile["2#Individual fix"].setComment("Controls each fix individually");
    pluginIniFile["2#Individual fix"]["FOV"] = fov_fix_enabled;
    pluginIniFile["2#Individual fix"]["Camera"] = Camera_fix_enabled;
    pluginIniFile["2#Individual fix"]["HUD"] = HUD_fix_enabled;
    pluginIniFile["2#Individual fix"]["Chromatic aberrations"] = CA_fix_enabled;
    pluginIniFile["2#Individual fix"]["Vignetting"] = Vignetting_fix_enabled;
    pluginIniFile["2#Individual fix"]["Fog"] = Fog_fix_enabled;
    pluginIniFile["2#Individual fix"]["Time dilation"] = Time_Dilation_fix_enabled;
    pluginIniFile["2#Individual fix"]["God Mode"] = GodMode_fix_enabled;
    pluginIniFile["2#Individual fix"]["Ignore hits"] = Ignore_hits_fix_enabled;
    pluginIniFile["2#Individual fix"]["Stealth"] = Stealth_fix_enabled;
    pluginIniFile["3#Fixes tuning"].setComment("Individual fix fine tune");
    pluginIniFile["3#Fixes tuning"]["World FOV"] = worldFOVValue;
    pluginIniFile["3#Fixes tuning"]["HUD scale"] = HUDScaleValue;
    pluginIniFile["3#Fixes tuning"]["Camera offset"] = cameraOffsetValue;
    pluginIniFile["3#Fixes tuning"]["World time dilation scale"] = worldTimeDilationValue;
    pluginIniFile["3#Fixes tuning"]["AI time dilation scale"] = AITimeDilationValue;
    pluginIniFile["3#Fixes tuning"]["Camera smoothness"] = cameraSmoothnessValue;

    pluginIniFile.save(SETTINGS_FILE);
}

static void LoadSettings() {
    ini::IniFile pluginIniFile;
    try {
        pluginIniFile.load(SETTINGS_FILE);
        fix_enabled                     = pluginIniFile["1#General fix"]["Enabled"].as<bool>();
        console                         = pluginIniFile["1#General fix"]["Console"].as<bool>();
        OSD_duration                    = pluginIniFile["1#General fix"]["OSD duration"].as<float>();
        fov_fix_enabled                 = pluginIniFile["2#Individual fix"]["FOV"].as<bool>();
        HUD_fix_enabled                 = pluginIniFile["2#Individual fix"]["HUD"].as<bool>();
        Camera_fix_enabled              = pluginIniFile["2#Individual fix"]["Camera"].as<bool>();
        CA_fix_enabled                  = pluginIniFile["2#Individual fix"]["Chromatic aberrations"].as<bool>();
        Vignetting_fix_enabled          = pluginIniFile["2#Individual fix"]["Vignetting"].as<bool>();
        Fog_fix_enabled                 = pluginIniFile["2#Individual fix"]["Fog"].as<bool>();
        Time_Dilation_fix_enabled       = pluginIniFile["2#Individual fix"]["Time dilation"].as<bool>();
        GodMode_fix_enabled             = pluginIniFile["2#Individual fix"]["God Mode"].as<bool>();
        Ignore_hits_fix_enabled         = pluginIniFile["2#Individual fix"]["Ignore hits"].as<bool>();
        Stealth_fix_enabled             = pluginIniFile["2#Individual fix"]["Stealth"].as<bool>();
        worldFOVValue                   = pluginIniFile["3#Fixes tuning"]["World FOV"].as<int>();
        HUDScaleValue                   = pluginIniFile["3#Fixes tuning"]["HUD scale"].as<int>();
        cameraOffsetValue               = pluginIniFile["3#Fixes tuning"]["Camera offset"].as<float>();
        worldTimeDilationValue          = pluginIniFile["3#Fixes tuning"]["World time dilation scale"].as<float>();
        AITimeDilationValue             = pluginIniFile["3#Fixes tuning"]["AI time dilation scale"].as<float>();
        cameraSmoothnessValue           = pluginIniFile["3#Fixes tuning"]["Camera smoothness"].as<float>();
    }
    catch (const std::exception& e) {}
}

// Read plugin log file
static std::string read_log_file(const std::string& filename) {
    std::ifstream file(filename);
    std::string log;
    if (!file.is_open()) {
        log = "Impossible to open file : " + filename;
        return log;
    }

    std::ostringstream ss;
    ss << file.rdbuf();
    log = ss.str();
    return log;
}

// Initialize ImGui widgets for Reshade
static void on_overlay_draw(reshade::api::effect_runtime* runtime) {
    ImGuiStyle& style = ImGui::GetStyle();
    style.ItemSpacing = ImVec2(8 * scale, 8 * scale);     // Spacing between widgets
    style.FramePadding = ImVec2(3 * scale, 3 * scale);    // Widgets padding
    style.WindowPadding = ImVec2(10 * scale, 10 * scale); // Overlay padding
    style.CellPadding = ImVec2(10 * scale, 10 * scale);   // Table cells padding

    ImGui::SetNextWindowSize(ImVec2(350 * scale, 150 * scale), ImGuiCond_Once);

    ImGui::PushStyleColor(ImGuiCol_Button, ImVec4(0.84f, 0.12f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_ButtonHovered, ImVec4(0.84f, 0.12f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_ButtonActive, ImVec4(0.84f, 0.2f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_Text, ImVec4(0.8f, 1.f, 1.f, 1.f)); // white
    if (ImGui::Button("Like my work ? Consider donation")) ShellExecuteA(NULL, "open", DONATION_URL, NULL, NULL, SW_SHOWNORMAL); // Donation
    ImGui::PopStyleColor(4); // Restore color
    ImGui::SameLine();
    if (ImGui::Button("Fix informations")) popup_Informations = true; // Fix information
    ImGui::SameLine();
    if (ImGui::Button("View logs")) {
        log_content = read_log_file("TheCallistoProtocol.log");
        show_log_overlay = true; // Fix information
    }

    if (popup_Informations) {
        ImGui::Begin("Informations", &popup_Informations, ImGuiWindowFlags_AlwaysAutoResize);
        ImGui::Text("Version : %s", FIX_VERSION);
        ImGui::Text(FIX_INFORMATIONS);
        ImGui::End();
    }

    if (show_log_overlay) {
        ImGui::Begin("Game log", &show_log_overlay, ImGuiWindowFlags_AlwaysAutoResize);
        ImGui::TextUnformatted(log_content.c_str());
        ImGui::End();
    }

    ImGui::PushStyleVar(ImGuiStyleVar_CellPadding, ImVec2(10 * scale, 10 * scale));
    if (ImGui::BeginTabBar("MainTabs")) {
        if (ImGui::BeginTabItem("Fixes")) {
            if (ImGui::BeginTable("FixesTable", 2, ImGuiTableFlags_SizingStretchSame)) {
                ImGui::TableSetupColumn("LeftFix", ImGuiTableColumnFlags_WidthStretch, 0.4f);
                ImGui::TableSetupColumn("RightFix", ImGuiTableColumnFlags_WidthStretch, 0.6f);
                ImGui::TableNextRow();

                // Drawing a left column with slider and general fix
                ImGui::TableSetColumnIndex(0);
                if (ImGui::CollapsingHeader("Enable fixes", ImGuiTreeNodeFlags_DefaultOpen))
                    if (ImGui::Checkbox("Fix enabled", &fix_enabled)) {
                        if (SetFixEnabled) SetFixEnabled(fix_enabled, false);
                        SaveSettings();
                    }

                // Individual fixes
                ImGui::TableSetColumnIndex(1);
                if (ImGui::CollapsingHeader("Individual fixes", ImGuiTreeNodeFlags_DefaultOpen)) {
                    if (ImGui::BeginTable("IndividualFixesTable", 2, ImGuiTableFlags_SizingStretchSame)) {
                        ImGui::TableSetupColumn("IndFix1", ImGuiTableColumnFlags_WidthStretch, 0.35f);
                        ImGui::TableSetupColumn("IndFix2", ImGuiTableColumnFlags_WidthStretch, 0.65f);
                        ImGui::TableNextRow();

                        ImGui::TableSetColumnIndex(0);
                        for (int i = 0; i < 3; ++i) DrawFixCheckbox(individualFixes[i]);
                        ImGui::TableSetColumnIndex(1);
                        for (int i = 3; i < IM_ARRAYSIZE(individualFixes); ++i) DrawFixCheckbox(individualFixes[i]);
                        ImGui::EndTable();
                    }
                }
                ImGui::EndTable();
            }

            // Sliders
            if (ImGui::BeginTable("SlidersTable", 2, ImGuiTableFlags_SizingStretchSame)) {
                ImGui::TableSetupColumn("LeftSliders", ImGuiTableColumnFlags_WidthStretch, 0.5f);
                ImGui::TableSetupColumn("RightSliders", ImGuiTableColumnFlags_WidthStretch, 0.5f);
                ImGui::TableNextRow();

                ImGui::TableSetColumnIndex(0);
                for (int i = 0; i < 2; ++i) DrawSlider(sliders[i], 200);
                ImGui::TableSetColumnIndex(1);
                for (int i = 2; i < 4; ++i) DrawSlider(sliders[i], 180);
                ImGui::EndTable();
            }
            ImGui::EndTabItem();
        }

        if (ImGui::BeginTabItem("Cheats"))
        {
            for (const auto& cheat : cheatFixes) DrawFixCheckbox(cheat);

            if (ImGui::BeginTable("SlidersTable", 2, ImGuiTableFlags_SizingStretchSame)) {
                ImGui::TableSetupColumn("LeftSliders", ImGuiTableColumnFlags_WidthStretch, 0.5f);
                ImGui::TableSetupColumn("RightSliders", ImGuiTableColumnFlags_WidthStretch, 0.5f);
                ImGui::TableNextRow();

                ImGui::TableSetColumnIndex(0);
                DrawSlider(sliders[4], 180);
                ImGui::TableSetColumnIndex(1);
                DrawSlider(sliders[5], 180);
                ImGui::EndTable();
            }
            ImGui::EndTabItem();
        }
        ImGui::EndTabBar();
    }
    ImGui::PopStyleVar();

    // Fix status
    if (ImGui::CollapsingHeader("Fix informations", ImGuiTreeNodeFlags_DefaultOpen)) {
        ImGui::Text("Screen width: %d, height: %d, aspect ratio: %.2f", screenWidth, screenHeight, aspectRatio);
        if (GetGameInfos) {
            GameInfos infos{};
            GetGameInfos(&infos);
            if (infos.consoleEnabled) ImGui::Text("Console enabled and bound to key F2");
            ImGui::TextColored(ImColor(48, 179, 25), "FOV In: %.2f, Out: %.2f, Pawn camera offset: %.2f", infos.FOVIn, infos.FOVOut, infos.CompensatedFOV);
        }
    }
}

static void on_reshade_present(reshade::api::effect_runtime* runtime) {
    static auto last = std::chrono::steady_clock::now();
    auto now = std::chrono::steady_clock::now();

    float dt = std::chrono::duration<float>(now - last).count();
    last = now;

    ProcessHotkeys(runtime);
    UpdateOSD(runtime, dt);
}

// Retrieve all shader uniform variables
static void on_reshade_begin_effects(reshade::api::effect_runtime* runtime, reshade::api::command_list* cmd_list,
                                     reshade::api::resource_view rtv, reshade::api::resource_view rtv_srgb) {
    if (!runtime) return;
    FindAllUniformVariables(runtime, OSD_SHADER_NAME); // Find all uniforms and set their handle

    if (InterlockedCompareExchange(&g_uniformReseted, 1, 0) != 0) return; // reset OSD uniforms once
    ResetAllUniformVariables(runtime, OSD_SHADER_NAME);
    runtime->save_current_preset(); // Save shader preset
}

static void InitializeHotkeys() { // Initialize hotkeys for cheats
    if (InterlockedCompareExchange(&g_hotkeysInitialized, 1, 0) != 0) return; // Initialize hotkeys once

    RegisterHotkey('1', Modifier::Alt, [] {
        ToggleOSD(Time_Dilation_fix_enabled, GameFixes::TimeDilation,
            u_td_show, u_td_enabled, OSD_duration,
            { {u_td_world, worldTimeDilationValue}, {u_td_AI, AITimeDilationValue} });
        });

    RegisterHotkey('2', Modifier::Alt, [] {
        ToggleOSD(GodMode_fix_enabled, GameFixes::GodMode, u_GodMode_show, u_GodMode_enabled, OSD_duration);
    });

    RegisterHotkey('3', Modifier::Alt, [] {
        ToggleOSD(Ignore_hits_fix_enabled, GameFixes::IgnoreHits, u_IgnoreHits_show, u_IgnoreHits_enabled, OSD_duration);
    });

    RegisterHotkey('4', Modifier::Alt, [] {
        ToggleOSD(Stealth_fix_enabled, GameFixes::Stealth, u_Stealth_show, u_Stealth_enabled, OSD_duration);
    });
}

// Main dll intrance
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD ul_reason_for_call, LPVOID)
{
    switch (ul_reason_for_call)
    {
        case DLL_PROCESS_ATTACH:
            if (!reshade::register_addon(hinstDLL))
                return FALSE;
            LoadSettings();

            reshade::register_overlay("The Callisto Protocol", &on_overlay_draw);
            reshade::register_event<reshade::addon_event::init_effect_runtime>(
                [](reshade::api::effect_runtime* runtime) {
                    LoadFixDLL();
                    InitializeHotkeys();
                });
            reshade::register_event<reshade::addon_event::reshade_present>(&on_reshade_present);
            reshade::register_event<reshade::addon_event::reshade_begin_effects>(&on_reshade_begin_effects);
            break;
        case DLL_PROCESS_DETACH:
            reshade::unregister_event<reshade::addon_event::reshade_present>(&on_reshade_present);
            reshade::unregister_event<reshade::addon_event::reshade_begin_effects>(&on_reshade_begin_effects);
            reshade::unregister_addon(hinstDLL);
            break;
    }
    return TRUE;
}